您的位置:首页 > 其它

hdu 1385(最短路+输出路径)

2016-05-14 13:03 344 查看

Minimum Transport Cost

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

[align=left]Problem Description[/align]
These are N cities in Spring country. Between each pair of cities there may be one transportation track or none. Now there is some cargo that should be delivered from one city to another. The transportation fee consists of two parts:

The cost of the transportation on the path between these cities, and

a certain tax which will be charged whenever any cargo passing through one city, except for the source and the destination cities.

You must write a program to find the route which has the minimum cost.

 

[align=left]Input[/align]
First is N, number of cities. N = 0 indicates the end of input.

The data of path cost, city tax, source and destination cities are given in the input, which is of the form:

a11 a12 ... a1N

a21 a22 ... a2N

...............

aN1 aN2 ... aNN

b1 b2 ... bN

c d

e f

...

g h

where aij is the transport cost from city i to city j, aij = -1 indicates there is no direct path between city i and city j. bi represents the tax of passing through city i. And the cargo is to be delivered from city c to city d, city e to city f, ..., and
g = h = -1. You must output the sequence of cities passed by and the total cost which is of the form:

 

[align=left]Output[/align]
From c to d :

Path: c-->c1-->......-->ck-->d

Total cost : ......

......

From e to f :

Path: e-->e1-->..........-->ek-->f

Total cost : ......

Note: if there are more minimal paths, output the lexically smallest one. Print a blank line after each test case.

 

[align=left]Sample Input[/align]

5
0 3 22 -1 4
3 0 5 -1 -1
22 5 0 9 20
-1 -1 9 0 4
4 -1 20 4 0
5 17 8 3 1
1 3
3 5
2 4
-1 -1
0

 

[align=left]Sample Output[/align]

From 1 to 3 :
Path: 1-->5-->4-->3
Total cost : 21

From 3 to 5 :
Path: 3-->4-->5
Total cost : 16

From 2 to 4 :
Path: 2-->1-->5-->4
Total cost : 17

 

解题思路:
这题我一开始用迪杰斯特拉,然后在进行松弛操作时用set记录更新其的父节点,set会自动排序,所以第一个数会是字典序最小的,接着逆着找即可。
但这样做会出现bug,因为字典序的比较是按位来一个个比较,如果只靠其父亲节点是无法保证一定是最小字典序的。
正解:Floyd,path[i][j]表示从i->j所经过的第一个点。接下来松弛操作就更新其即可。

WA:
#include<iostream>
#include<cstdio>
#include<cstring>
#include<set>
using namespace std;

const int maxn = 105;
const int inf = 0x3f3f3f3f;
int n,map[maxn][maxn],dis[maxn],cost[maxn],res[maxn];
bool vis[maxn];
set<int> Set[maxn];

void Dijkstra(int s)
{
int k,MIN;
memset(vis,false,sizeof(vis));
for(int i = 1; i <= n; i++)
if(i != s)
{
dis[i] = map[s][i] + cost[i];
Set[i].insert(s);
}
vis[s] = true;
for(int i = 1; i < n; i++)
{
MIN = inf;
for(int j = 1; j <= n; j++)
{
if(vis[j] == true) continue;
if(MIN > dis[j])
{
MIN = dis[j];
k = j;
}
}
vis[k] = true;
for(int j = 1; j <= n; j++)
{
if(vis[j] == true || dis[j] < dis[k] + map[k][j] + cost[j]) continue;
if(dis[j] > dis[k] + map[k][j] + cost[j])
{
dis[j] = dis[k] + map[k][j] + cost[j];
Set[j].clear();
}
Set[j].insert(k);
printf("%d %d:\n",k,j);
set<int>::iterator it;
for(it = Set[j].begin(); it != Set[j].end(); it++)
printf("%d ",*it);
printf("\n");
}
}
}

void dfs(int u,int deep)
{
set<int>::iterator it = Set[u].begin();
if(it == Set[u].end())
{
if(deep == 0)
printf("%d",u);
else printf("%d-->",u);
return;
}
dfs(*it,deep+1);
if(deep == 0)
printf("%d",u);
else printf("%d-->",u);
}

int main()
{
while(scanf("%d",&n),n)
{
for(int i = 1; i <= n; i++)
for(int j = 1; j <= n; j++)
{
scanf("%d",&map[i][j]);
if(map[i][j] == -1)
map[i][j] = inf;
}
for(int i = 1; i <= n; i++)
scanf("%d",&cost[i]);
int s,e;
while(scanf("%d%d",&s,&e)!=EOF)
{
if(s == -1 && e == -1) break;
for(int i = 1; i <= n; i++) Set[i].clear();
Dijkstra(s);
printf("From %d to %d :\nPath: ",s,e);
dfs(e,0);
printf("\nTotal cost : %d\n\n",dis[e] - cost[e]);
}
}
return 0;
}


AC:
#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;

const int maxn = 105;
const int inf = 0x3f3f3f3f;
int n,map[maxn][maxn],path[maxn][maxn],cost[maxn];

void init()
{
for(int i = 1; i <= n; i++)
for(int j = 1; j <= n; j++)
path[i][j] = j;
}

void floyd()
{
for(int k = 1; k <= n; k++)
for(int i = 1; i <= n; i++)
for(int j = 1; j <= n; j++)
{
if(map[i][j] > map[i][k] + map[k][j] + cost[k])
{
map[i][j] = map[i][k] + map[k][j] + cost[k];
path[i][j] = path[i][k];
}
else if(map[i][j] == map[i][k] + map[k][j] + cost[k])
path[i][j] = min(path[i][j],path[i][k]);
}
}

int main()
{
while(scanf("%d",&n),n)
{
for(int i = 1; i <= n; i++)
for(int j = 1; j <= n; j++)
{
scanf("%d",&map[i][j]);
if(map[i][j] == -1)
map[i][j] = inf;
}
for(int i = 1; i <= n; i++)
scanf("%d",&cost[i]);
init();
floyd();
int s,e;
while(scanf("%d%d",&s,&e)!=EOF)
{
if(s == -1 && e == -1) break;
printf("From %d to %d :\n",s,e);
printf("Path: ");
int u = s;
printf("%d",u);
while(u != e){
printf("-->%d",path[u][e]);
u = path[u][e];
}
printf("\nTotal cost : %d\n\n", map[s][e]);
}
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  图论